<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托商:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" name="entrustCode" placeholder="请输入委托编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                     class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg"  @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <FileManage ref="FileManage"></FileManage>
    <Reason ref="reasonModal" @on-result-change="_reasonResult"></Reason>
    <Operation ref="operation"></Operation>
    <EntrustDetail ref="sampleEdit"></EntrustDetail>
    <SampleManage ref="sampleManageModal"></SampleManage>
    <SelectFlowRelBtn ref="flow"/>
  </div>
</template>
<script>
import { soilEntrust } from '../../../api'
import Operation from '../../../components/operation/Operation'
import Reason from '../../../components/base/Reason'
import SampleManage from '../SoilSampleManage'
import global from '../../../api/config'
import EntrustDetail from './EntrustDetail'
import SelectFlowRelBtn from './SelectFlowRelBtn'
export default {
  components: {
    Operation,
    Reason,
    EntrustDetail,
    SampleManage,
    SelectFlowRelBtn
  },
  data() {
    return {
      currentComponent: 'FoodSampleGovern',
      formId: 'meterReviewEntrustFormId',
      searchOpen: false,
      btn: [
        {
          // meter-review-entrust-pass-btn
          type: 'success',
          id: 'review-pass',
          name: '通过'
        },
        // meter-review-entrust-back-btn
        {
          type: 'success',
          id: 'review-back',
          name: '驳回'
        },
        {
          type: 'success',
          id: 'review-export',
          name: '导出标书合同(协议)评审表模板'
        },
        {
          type: 'success',
          id: 'review-export-plus',
          name: '导出标书合同（协议）补充单模板'
        },
        {
          type: 'success',
          id: 'submit-flow',
          name: '提交审批'
        }
      ],
      iconMsg: [
        {
          type: 'md-paper',
          id: 'review-detail',
          name: '详情'
        },
        {
          type: 'ios-beaker',
          id: 'review-sample-manage',
          name: '样品管理'
        },
        {
          type: 'md-cloud',
          id: 'review-upload',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: 'review-record',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        contractCode: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托商', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托日期', key: 'entrustDate', width: 120, date: true },
        { title: '钻孔位置', key: 'boreholeLocation', width: 120 },
        { title: '水深（米）', key: 'waterDepth', width: 120 },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        { title: '平均容重', key: 'projectNo', width: 120 },
        { title: '制表日期', key: 'tabulateDate', width: 120, date: true },
        { title: '制表人', key: 'tabulater', width: 120 },
        { title: '批准日期', key: 'approveDate', width: 120, date: true },
        { title: '批准人', key: 'approver', width: 120 },
        { title: '检验类别', key: 'testType', width: 120 }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _detailModal(data) {
      console.log(data)
      this.$refs.sampleEdit._open(data)
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '提交审批':
            this._submit('submit-flow')
            break
          case '驳回':
            this._goBack()
            break
          case '添加':
            this._editModal(false)
            break
          case '通过':
            this._passReview()
            break
          case '导出标书合同(协议)评审表模板':
            this._exportTemplate()
            break
          case '导出标书合同（协议）补充单模板':
            this._exportTemplatePlus()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _submit(key) {
      this.$refs.flow._open(key)
    },
    _exportTemplate() {
      const data = {
        downloadUrl:
          '/soil/v1/excel/template_soil/TenderContractEvaluationForm.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _exportTemplatePlus() {
      const data = {
        downloadUrl:
          '/soil/v1/excel/template_soil/TenderContractSupplement.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _download(data) {
      window.open(global.baseURL + data.downloadUrl, '_blank')
    },
    _goBack() {
      // 退回
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条委托！')
      } else {
        this.$refs.reasonModal._open('退回原因')
      }
    },
    _reasonResult(data) {
      this.$refs.pageTable._showLoading()
      if (undefined !== data && data !== '') {
        this._reportCheckBack(data)
      }
    },
    _reportCheckBack: async function(data) {
      const result = await soilEntrust.back({
        ids: this.selectIds,
        remark: data
      })

      if (result) {
        this.$Message.success('退回成功！')
        await this._page()
        this.$refs.pageTable._hideLoading()
      }
    },
    _iconClick(res, data) {
      this.$nextTick(function() {
        switch (res) {
          case '样品管理':
            this._manageSample(data.id)
            break
          case '详情':
            this._detailModal(data)
            break
          case '编辑':
            this._editModal(true, data.id)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _manageSample(data) {
      // 管理样品
      this.$refs.sampleManageModal._open(data)
    },
    _record(id) {
      this.$refs.operation._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
        case 'selectIds':
          this.selectIds = data
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilEntrust.pageReview(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },

    _passReview() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要通过评审的委托单！')
        return false
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定通过该委托单？',
        onOk: () => {
          this.$refs.pageTable._showLoading()
          this._passEntrustReview(this.selectIds)
        }
      })
    },
    _passEntrustReview: async function(ids) {
      const result = await soilEntrust.reviewPass(ids)
      if (result) {
        this.$Message.success('提交成功！')
        await this._page()
        this.$refs.pageTable._hideLoading()
      }
    },

    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'entrustId')
    }
    // _getById: async function(id) {
    //   const result = await meterSubcontractor.getById(id)
    //   if (result) {
    //     this.$refs.editSubcontractorModal._open(result)
    //   }
    // },
    // _delete: async function(ids) {
    //   const result = await meterSubcontractor.deleteById(ids)
    //   if (result) {
    //     this._formSearch()
    //     this.$Message.success('删除成功！')
    //   }
    // }
  }
}
</script>
